
# VSCode/IDE integration

## Introduction

Once a [docker build environment](./Docker.md) has been prepared for
this project, linking your preferred IDE with it is straightforward thanks to
[x-builder](https://gitlab.cern.ch/mro/common/tools/x-builder).

Integration is made by replacing tools with their *x-builder* equivalent, all
developers using the same set of tools and level of integration on their workspace.

This document will focus on [Visual Studio Code](https://code.visualstudio.com)
or [VSCodium](https://vscodium.com) extensions, but other IDE such as
[Qt Creator](https://www.qt.io/product/development-tools) is easily achievable.

## Tasks integration

[VSCode tasks](https://code.visualstudio.com/docs/editor/tasks#vscode) simply
need to run `x-builder` as a command and the in-container command as an argument.

Here's an example **tasks.json** configuration file (also available here: [.vscode/tasks.json](../.vscode/tasks.json)):
```json
{
    "version": "2.0.0",
    "tasks": [
        {
            "label": "build: make lint",
            "command": "x-builder",
            "args": [ "make", "-C", "build", "lint" ],
            "problemMatcher": {
                "owner": "cpp",
                "fileLocation": "autoDetect",
                "pattern": {
                    "regexp": "^(.*):(\\d+):(\\d+):\\s+(warning|error):\\s+(.*)$",
                    "file": 1,
                    "line": 2,
                    "column": 3,
                    "severity": 4,
                    "message": 5
                }
            },
            "group": {
                "kind": "test",
                "isDefault": true
            }
        }
    ]
}
```

## Extensions integration

The following extensions are used in our team (may change depending on need):
- [c-cpp-flylint](https://marketplace.visualstudio.com/items?itemName=jbenden.c-cpp-flylint) for linting (CppCheck, Clang)
- [clang-format](https://marketplace.visualstudio.com/items?itemName=xaver.clang-format) for styling
- [vscode-clangd](https://marketplace.visualstudio.com/items?itemName=llvm-vs-code-extensions.vscode-clangd) for the language-server (code-completion)

✋ Some of those tools may support to replace their *executable* with `x-builder <exe>`,
but most of those will try to `exec` it, failing to execute such a thing, to work this arround
*x-builder* proposes several levels of integration:

1. Simple symlinks:
```bash
# x-builder will detect that it has been called with "clangd" suffix and
# will automatically run clangd inside the container
ln -s ~/bin/x-builder ~/bin/x-builder-clangd
```

2. Small wrapper scripts:
```bash
# Example "x-builder-clang" script that will load configuration generated by CMake
BINDIR=$(cd $(dirname $0); pwd)
[ -e "${BINDIR}/.functions.sh" ] && . "${BINDIR}/.functions.sh"

NAME=$(basename $0)

cd `realpath .`

[ -e ".clang_complete" ] && OPTS=$(cat .clang_complete)

exec x-builder "${NAME/x-builder-/}" "$@" ${OPTS}
```

👉 Most of those scripts are already provided and installed by *x-builder* so
nothing to really worry about.

Here's an example **settings.json** file (also available here: [.vscode/settings.json](../.vscode/settings.json)):
```json
{
    "c-cpp-flylint.cppcheck.executable": "x-builder-cppcheck",
    "c-cpp-flylint.clang.executable": "x-builder-clang",
    "clang-format.executable": "x-builder-clang-format",
    "clangd.path": "x-builder-clangd"
}
```

🥳 with those few configuration files *x-builder* is fully integrated in
*VSCodium* !

### CMake extension integration

[CMake Tools](https://marketplace.visualstudio.com/items?itemName=ms-vscode.cmake-tools) extension
does a bit more than simply wrapping CMake, thus its integration required some efforts.

Do create the following files:
- [.vscode/x-builder-cmake](../.vscode/x-builder-cmake)
- Two symlinks:
    - `x-builder-ctest -> x-builder-cmake`
    - `x-builder-gdb -> x-builder-cmake`

And then adds the following configuration in [.vscode/settings.json](../.vscode/settings.json):
```
{
    "cmake.cmakePath": "${workspaceFolder}/.vscode/x-builder-cmake",
    "cmake.generator": "Unix Makefiles",
    "cmake.ctestPath": "${workspaceFolder}/.vscode/x-builder-ctest"
}
```

🥳 And that's it !

#### Detailed explanations

This extension runs CMake executable to test available version and features, the inconvenient is
that it does it without setting the current working directory (see [cmakeExecutable.ts](https://github.com/microsoft/vscode-cmake-tools/blob/3472ca7c9aa4fd565f74fcd4e17b5962a5ead4bc/src/cmake/cmakeExecutable.ts#L40),
it spawns it from the directory you started VSCode from.

To work this arround a small script has been created here: [.vscode/xbuilder-cmake](../.vscode/x-builder-cmake)

By comparing current directory with the project's directory and eventually moving to it:
```bash
[[ "$CURRENT_DIR" =~ ^${PROJECT_DIR}/.* ]] || cd "$(dirname $0)/.."
```

Second issue is that it then calls CMake from project's build directories,
[x-builder](https://gitlab.cern.ch/mro/common/tools/x-builder) has been upgraded to support this, here: [PR#2](https://gitlab.cern.ch/mro/common/tools/x-builder/-/merge_requests/2)


#### Integration for cross-compilation

To provide a better user-experience and go into this extension's direction,
the following was prepared:
- a [CMakePresets.json](../CMakePresets.json) file describing different ways to build and test this application
    - this may eventually be used in CI instead of manually invoking CMake and provides two contexts:
        1. "Build for tests" : native (as in native for the container) build to run unit-tests
        2. "Build for device" : device or emulator build using the toolchain-file
- a [.vscode/launch.json](../.vscode/launch.json) file describing how to run applications
    - it runs the application selected in CMake menu, and provides three different running contexts:
        1. *"(gdb) Launch"* : will start native gdb within the container
        2. *"(AVR gdb) Launch"* : will start target avr-gdb and hook the target from within the container
        2. *"(AVR gdb) Simulation"* : will start target avr-gdb along with a simulator within the container
- (optional) a kit file describing where to find the toolchain [.vscode/cmake-kits.json](../.vscode/cmake-kits.json)
    - optional and not really used, just handy for debugging

Due to the way CMake targets are parsed by this extension (see: [cmakeProject.ts#L2758](https://github.com/microsoft/vscode-cmake-tools/blob/3472ca7c9aa4fd565f74fcd4e17b5962a5ead4bc/src/cmakeProject.ts#L2758) and [cmakeProject.ts#L2795](https://github.com/microsoft/vscode-cmake-tools/blob/3472ca7c9aa4fd565f74fcd4e17b5962a5ead4bc/src/cmakeProject.ts#L2795)), it seemed rather
complicated to try to integrate the extensions provided run/debug buttons when cross-compiling (this is not related to x-builder),
thus the *launch.json* file as recommended in the [extension's documentation](https://github.com/microsoft/vscode-cmake-tools/blob/3472ca7c9aa4fd565f74fcd4e17b5962a5ead4bc/docs/debug-launch.md#debug-using-a-launchjson-file).

#### Known Issues

The `lint` rule provided by our CMake script displays warnings using
source-relative directories, this is on purpose to ease GitLab-CI integration. \
Issue is that *CMake Tools* plugin will map those files relatively to the build directory, generating a report with invalid links to code.

This is a known issue that was reported here: [#1401](https://github.com/microsoft/vscode-cmake-tools/issues/1401).

Rather than trying to work this arround and impact our CMake scripts with this known issue,
I decided to ship them a PR, here: [PR#3780](https://github.com/microsoft/vscode-cmake-tools/pull/3780).

So this issue should be fixed in next releases (if upstreams validates the PR).